<script lang="ts" setup>
// import Graph from "../components/Graph.vue";
import {
  groupsGetGroups,
  type Unit,
  unitsGetUnits,
} from "@/scripts/api-helper";
import {
  unitFromCode,
  findUnitPath,
  unitToUnitsTree,
} from "@/scripts/algorithms";
import { computed, reactive } from "vue";
import { useRoute } from "vue-router";
import Breadcrumb from "@/components/Breadcrumb.vue";
import type { UnitsTree, BreadcrumbRoute } from "@/scripts/client-types";
import DataTable from "@/components/DataTable.vue";
import SubunitsView from "@/components/units/SubunitsView.vue";
import { useQuery } from "vue-query";
import UnitCard from "@/components/UnitCard.vue";
import GroupCard from "@/components/GroupCard.vue";
import router from "@/router";

const route = useRoute();

const unit_code = route.params.unit_code as string;

const state = reactive({
  unit: null as Unit | null,
  unitsTree: null as UnitsTree | null,
  path: [] as BreadcrumbRoute[],
  tab: "" as string,
  hideSubunits: false,
});

const { isSuccess: unitsIsSuccess, data: unitsData } = useQuery(
  "get-all-units",
  async () => {
    const res = await unitsGetUnits({});
    if (!res.ok) {
      throw new Error("Failed to get units");
    }
    return res.data;
  }
);

const unitQueryEnabled = computed(() => !!unitsIsSuccess);

const {
  isLoading: unitIsLoading,
  isError: unitIsError,
  data: unitData,
} = useQuery(
  `unit-${unit_code}`,
  async () => {
    const res = await unitsGetUnits({ code: unit_code });
    if (!res.ok) {
      throw new Error("Failed to get unit");
    }
    state.unitsTree = unitToUnitsTree(res.data[0], unitsData.value!);
    state.path = findUnitPath(res.data[0], unitsData.value!).map((code) => ({
      text: code,
      path: `/units/${code}`,
    }));
    return res.data[0];
  },
  {
    enabled: unitQueryEnabled,
  }
);

const {
  isLoading: groupsIsLoading,
  isError: groupsIsError,
  data: groupsData,
} = useQuery(`groups-of-unit-${unit_code}`, async () => {
  const res = await groupsGetGroups({ unit: unit_code });
  if (!res.ok) {
    throw new Error("Failed to get unit's groups");
  }
  return res.data;
});
</script>

<template>
  <div>
    <div v-if="unitIsLoading" class="flex flex-row justify-center">
      <v-progress-circular
        :size="74"
        :width="11"
        indeterminate
      ></v-progress-circular>
    </div>
    <div v-if="unitIsError">
      <h1>Impossible d'afficher l'unité</h1>
    </div>
    <div v-else class="flex flex-col items-center w-full">
      <Breadcrumb
        :key="route.fullPath"
        :ancestors="state.path"
        home="/units"
      ></Breadcrumb>

      <div class="flex flex-col md:flex-row justify-center items-center">
        <p class="text-4xl text-center">{{ unitData?.code }}</p>
        <p class="text-3xl hidden md:block mx-4">-</p>
        <p class="text-theme-text-darker text-3xl text-center">
          {{ unitData?.display_name }}
        </p>
      </div>

      <div class="flex pt-3 flex-col w-full">
        <SubunitsView
          v-if="state.unitsTree?.sub_units.length > 0"
          :units="state.unitsTree?.sub_units"
          class=""
        />

        <div class="flex flex-col justify-center mb-3">
          <h3 class="text-2xl py-3">Accréditations dans l'unité :</h3>
          <v-card class="max-w-md xs:max-w-xl sm:max-w-2xl md:max-w-full">
            <DataTable />
          </v-card>
        </div>

        <div class="flex flex-col justify-center mb-3">
          <h3 class="text-2xl py-3">Groupes de l'unité</h3>
          <div v-if="groupsIsLoading" class="flex flex-row justify-center">
            <v-progress-circular
              :size="50"
              :width="8"
              indeterminate
            ></v-progress-circular>
          </div>
          <div v-else-if="groupsIsError">
            <p>Unable to load groups</p>
          </div>
          <div v-else>
            <div
              class="grid grid-cols-1 md:grid-cols-1 lg:grid-cols-2 2xl:grid-cols-3 gap-4"
            >
              <GroupCard
                v-for="g of groupsData"
                v-bind:key="g.name"
                :abv="g.abv"
                :name="g.name"
                :unit="g.unit_code"
                @click="router.push(`/groups/${g.uid}`)"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
